#include <windows.h>
#include "multi.h"




#ifndef H__GUI__H
#define H__GUI__H


class GUI
{
      public:
             HWND hwnd;
             UINT msg;      //Last Message
             WPARAM wparam; //"
             LPARAM lparam; //"
             GUI()
             {
                  hwnd=NULL;
                  msg=wparam=lparam=0;
             }
};

struct newGUI
{
       char *title;
       int w,h,style,exstyle,posx,posy;
       HWND parent;
       int guix;
       bool start;
       char *classname;
       bool useexstyle;
};


//Global
WNDCLASSEX wincl;
char clname[]="TheShadowAE's GUI-UDF";
int guis=0;
GUI *gui[50];
bool msgloop=true;
HANDLE thread;
HINSTANCE hinst;
newGUI *newG;
bool finished=false;



//Functions
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

//official
void GUIStartup();
void GUIShutdown();
GUI* GUICreate(char* title="",int w=300,int h=200,int style=WS_OVERLAPPEDWINDOW,int exstyle=0,HWND parent=HWND_DESKTOP,int posx=CW_USEDEFAULT,int posy=CW_USEDEFAULT);

//inofficial
DWORD WINAPI _Handler(LPVOID);





GUI* GUICreate(char* title,int w,int h,int style,int exstyle,HWND parent,int posx,int posy)
{
    guis+=1;
    if (guis>50)
    {
         guis=50;
         MessageBox(0,"Nicht mehr als 50 GUIs erlaubt!","Achtung!",MB_OK|MB_ICONERROR);
    }
    int x;
    for (x=0; x<guis; x++) if (gui[x]->hwnd==NULL) {newG->guix=x; break;};
    newG->title=title;
    newG->w=w;
    newG->h=h;
    newG->style=style;
    newG->exstyle=exstyle;
    newG->parent=parent;
    newG->posx=posx;
    newG->posy=posy;
    newG->classname=clname;
    newG->useexstyle=true;
    newG->start=true;
    while(!finished) Sleep(10);
    finished=false;
    return gui[x];
}

void GUIStartup()
{//NULL_BRUSH, GRAY_BRUSH, GetStockObject, CreateSolidBrush(RGB(,,))
    for(int x=0; x<50; x++)
    {
        static GUI *ngui=new GUI();
        gui[x]=ngui;
    }
    hinst=GetModuleHandle(NULL);
    wincl.hInstance = hinst;//hInstanceA
    wincl.lpszClassName = clname;
    wincl.lpfnWndProc = WindowProcedure;
    wincl.style = CS_DBLCLKS;//catch Doubleclicks
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;//no menu
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
    RegisterClassEx(&wincl);
    newG=new newGUI;
    newG->start=false;
    msgloop=true;
    thread=CreateThread(NULL,0,_Handler,NULL,0,NULL);
}

void GUIShutdown()
{
     for(int x=0; x<50; x++)
     {
         //PostMessage(gui[x]->hwnd,WM_DESTROY,0,0);
         DestroyWindow(gui[x]->hwnd);
         delete gui[x];
     }
     msgloop=false;
     WaitForSingleObject(thread,5000);
     SuspendThread(thread);
     TerminateThread(thread,1);
     CloseHandle(thread);
}


DWORD WINAPI _Handler(LPVOID muell)
{
    MSG messages;
    while(msgloop)
    {
        if(PeekMessage(&messages,NULL,0,0,PM_REMOVE)) //PM_REMOVE oder 0
        {
            TranslateMessage(&messages);
            DispatchMessage(&messages);
        }
        if(newG->start)
        {
            GUI *ngui;
            ngui=gui[newG->guix];
            if(newG->useexstyle) {
            ngui->hwnd = CreateWindowEx (
                 newG->exstyle,       /* Extended possibilites for variation */
                 newG->classname,              /* Classname */
                 newG->title,         /* Title Text */
                 newG->style,         /* default window */
                 newG->posx,          /* Windows decides the position */
                 newG->posy,          /* where the window ends up on the screen */
                 newG->w,             /* The programs width */
                 newG->h,             /* and height in pixels */
                 newG->parent,        /* The window is a child-window to desktop */
                 NULL,                /* No menu */
                 hinst,               /* Program Instance handler */
                 NULL                 /* No Window Creation data */
                 );
            } else {
            ngui->hwnd = CreateWindow(
                 newG->classname,              /* Classname */
                 newG->title,         /* Title Text */
                 newG->style,         /* default window */
                 newG->posx,          /* Windows decides the position */
                 newG->posy,          /* where the window ends up on the screen */
                 newG->w,             /* The programs width */
                 newG->h,             /* and height in pixels */
                 newG->parent,        /* The window is a child-window to desktop */
                 NULL,                /* No menu */
                 hinst,               /* Program Instance handler */
                 NULL                 /* No Window Creation data */
                 );
            }
            finished=true;
            newG->start=false;
        }
        Sleep(10);
    }
    return messages.wParam;
}




LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    GUI *ngui;
    bool wasin=false;
    for (int x=0; x<guis; x++)
    {
        if(gui[x]->hwnd==hwnd)
        {
             ngui=gui[x];
             wasin=true;
             break;
        }
    }
    if(!wasin) return DefWindowProc (hwnd, message, wParam, lParam);
    switch (message)
    {
        case WM_DESTROY:
            PostQuitMessage(0);
            guis-=1;
            ngui->hwnd=NULL;
            break;
        default:
            ngui->lparam=lParam;
            ngui->wparam=wParam;
            ngui->msg=message;
            if(message==WM_CLOSE) return 0;
            return DefWindowProc (hwnd, message, wParam, lParam);
    }
    return 0;
}


#endif

